bilateral.h
/*
* Software License Agreement (BSD License)
*
* Point Cloud Library (PCL) - www.pointclouds.org
* Copyright (c) 2010-2011, Willow Garage, Inc.
*
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
* * Redistributions of source code must retain the above copyright
* notice, this list of conditions and the following disclaimer.
* * Redistributions in binary form must reproduce the above
* copyright notice, this list of conditions and the following
* disclaimer in the documentation and/or other materials provided
* with the distribution.
* * Neither the name of the copyright holder(s) nor the names of its
* contributors may be used to endorse or promote products derived
* from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
* FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
* COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
* LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
* ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
*
* $Id$
*
*/
#ifndef PCL_FILTERS_BILATERAL_H_
#define PCL_FILTERS_BILATERAL_H_
#include <pcl/filters/filter.h>
#include <pcl/search/pcl_search.h>
namespace pcl
{
/** \brief A bilateral filter implementation for point cloud data. Uses the intensity data channel.
* \note For more information please see
* <b>C. Tomasi and R. Manduchi. Bilateral Filtering for Gray and Color Images.
* In Proceedings of the IEEE International Conference on Computer Vision,
* 1998.</b>
* \author Luca Penasa
* \ingroup filters
*/
template<typename PointT>
class BilateralFilter : public Filter<PointT>
{
using Filter<PointT>::input_;
using Filter<PointT>::indices_;
typedef typename Filter<PointT>::PointCloud PointCloud;
typedef typename pcl::search::Search<PointT>::Ptr KdTreePtr;
public:
typedef boost::shared_ptr< BilateralFilter<PointT> > Ptr;
typedef boost::shared_ptr< const BilateralFilter<PointT> > ConstPtr;
/** \brief Constructor.
* Sets sigma_s_ to 0 and sigma_r_ to MAXDBL
*/
BilateralFilter () : sigma_s_ (0),
sigma_r_ (std::numeric_limits<double>::max ()),
tree_ ()
{
}
/** \brief Filter the input data and store the results into output
* \param[out] output the resultant point cloud message
*/
void
applyFilter (PointCloud &output);
/** \brief Compute the intensity average for a single point
* \param[in] pid the point index to compute the weight for
* \param[in] indices the set of nearest neighor indices
* \param[in] distances the set of nearest neighbor distances
* \return the intensity average at a given point index
*/
double
computePointWeight (const int pid, const std::vector<int> &indices, const std::vector<float> &distances);
/** \brief Set the half size of the Gaussian bilateral filter window.
* \param[in] sigma_s the half size of the Gaussian bilateral filter window to use
*/
inline void
setHalfSize (const double sigma_s)
{ sigma_s_ = sigma_s; }
/** \brief Get the half size of the Gaussian bilateral filter window as set by the user. */
inline double
getHalfSize () const
{ return (sigma_s_); }
/** \brief Set the standard deviation parameter
* \param[in] sigma_r the new standard deviation parameter
*/
inline void
setStdDev (const double sigma_r)
{ sigma_r_ = sigma_r;}
/** \brief Get the value of the current standard deviation parameter of the bilateral filter. */
inline double
getStdDev () const
{ return (sigma_r_); }
/** \brief Provide a pointer to the search object.
* \param[in] tree a pointer to the spatial search object.
*/
inline void
setSearchMethod (const KdTreePtr &tree)
{ tree_ = tree; }
private:
/** \brief The bilateral filter Gaussian distance kernel.
* \param[in] x the spatial distance (distance or intensity)
* \param[in] sigma standard deviation
*/
inline double
kernel (double x, double sigma)
{ return (exp (- (x*x)/(2*sigma*sigma))); }
/** \brief The half size of the Gaussian bilateral filter window (e.g., spatial extents in Euclidean). */
double sigma_s_;
/** \brief The standard deviation of the bilateral filter (e.g., standard deviation in intensity). */
double sigma_r_;
/** \brief A pointer to the spatial search object. */
KdTreePtr tree_;
};
}
#ifdef PCL_NO_PRECOMPILE
#include <pcl/filters/impl/bilateral.hpp>
#endif
#endif // PCL_FILTERS_BILATERAL_H_
pcl::BilateralFilter::setHalfSize
void setHalfSize(const double sigma_s)
Set the half size of the Gaussian bilateral filter window.
Definition: bilateral.h:99
pcl
Definition: convolution.h:45
pcl::kernel
Definition: kernel.h:45
pcl::BilateralFilter::applyFilter
void applyFilter(PointCloud &output)
Filter the input data and store the results into output.
Definition: bilateral.hpp:73
pcl::BilateralFilter::getStdDev
double getStdDev() const
Get the value of the current standard deviation parameter of the bilateral filter.
Definition: bilateral.h:116
std
Definition: multi_grid_octree_data.hpp:45
pcl::Filter
Filter represents the base filter class.
Definition: filter.h:84
pcl::BilateralFilter
A bilateral filter implementation for point cloud data.
Definition: bilateral.h:57
pcl::search::Search::Ptr
boost::shared_ptr< pcl::search::Search< PointT > > Ptr
Definition: search.h:81
pcl::BilateralFilter::ConstPtr
boost::shared_ptr< const BilateralFilter< PointT > > ConstPtr
Definition: bilateral.h:67
pcl::PointCloud
PointCloud represents the base class in PCL for storing collections of 3D points. ...
Definition: projection_matrix.h:53
pcl::BilateralFilter::Ptr
boost::shared_ptr< BilateralFilter< PointT > > Ptr
Definition: bilateral.h:66
pcl::BilateralFilter::setStdDev
void setStdDev(const double sigma_r)
Set the standard deviation parameter.
Definition: bilateral.h:111
pcl::BilateralFilter::computePointWeight
double computePointWeight(const int pid, const std::vector< int > &indices, const std::vector< float > &distances)
Compute the intensity average for a single point.
Definition: bilateral.hpp:47
pcl::BilateralFilter::BilateralFilter
BilateralFilter()
Constructor.
Definition: bilateral.h:73
pcl::BilateralFilter::getHalfSize
double getHalfSize() const
Get the half size of the Gaussian bilateral filter window as set by the user.
Definition: bilateral.h:104
pcl::BilateralFilter::setSearchMethod
void setSearchMethod(const KdTreePtr &tree)
Provide a pointer to the search object.
Definition: bilateral.h:123